const path = require('path')
const postcss = require('postcss')
const postcssrc = require('postcss-load-config')

const postCSSProcess = (css, postcssrcOptions = {}) => {
  return postcssrc({
    env: process.env.NODE_ENV ?? 'development',
    options: { from: undefined },
    ...postcssrcOptions
  }).then(({ plugins, options }) => {
    return postcss(plugins).process(css, options)
  })
}

module.exports = function () {
  const cssModuleRegExp = /((.*)\.vue)\?rollup-plugin-vue=styles\.(.*)\.css$/
  // Relative asset subdirectory from rollup output dir
  const styleOutputDir = 'style'
  // Function to check if module id is a css file generated by rollup-plugin-vue
  const isCSSModule = (moduleId) => {
    const match = cssModuleRegExp.exec(moduleId)
    return Boolean(match)
  }
  const vueComponentStylesEntryPoints = {
    '.css': {
      assetRef: undefined, // will be set after emit
      assetFileName: `${styleOutputDir}/components/index.css`,
      // Default source
      source: '/**\n * Vue component styles entrypoint: .css\n */\n'
    }
    // '.sass': {
    //   assetRef: undefined, // will be set after emit
    //   assetFileName: `${styleOutputDir}/components/index.sass`
    // },
  }
  const extracted = []
  let getFilename
  return {
    name: 'extract-css', // this name will show up in logs and errors
    buildStart (options) {
      const firstEntryKey = Object.keys(options.input)[0]
      const mainEntry = path.isAbsolute(options.input[firstEntryKey])
        ? options.input[firstEntryKey]
        : path.resolve(process.cwd(), options.input[firstEntryKey])

      const rootSubDir = path.dirname(path.relative(process.cwd(), mainEntry))

      getFilename = (moduleId) => {
        return path.relative(path.join(process.cwd(), rootSubDir), cssModuleRegExp.exec(moduleId)[2])
      }

      // Emit Vue component styles entry points
      for (const targetExtension in vueComponentStylesEntryPoints) {
        vueComponentStylesEntryPoints[targetExtension].assetRef = this.emitFile({
          type: 'asset',
          fileName: vueComponentStylesEntryPoints[targetExtension].assetFileName
          // dont set source at emitting. see buildEnd hook
        })
      }
    },
    transform (code, id) {
      if (isCSSModule(id)) {
        // // Skip empty files
        if (code.replace(/\s/g, '') === '') return null
        const extension = '.css'
        const sfcFileName = `${getFilename(id)}.vue`
        // Always return a "posix" formatted path like 'path/to/asset.css
        const buildDefaultAssetFileName = (basename, extension = '.css') => path.join(styleOutputDir, `${basename}${extension}`).split(path.sep).join(path.posix.sep)
        // Define asset targets
        const extractedInfos = [
          // .css (not minified)
          {
            moduleId: id,
            fileName: sfcFileName,
            extension: extension,
            defaulAssetName: buildDefaultAssetFileName(getFilename(id), extension),
            assetRef: undefined, // will be set after emit
            assetFileName: undefined // will be set after emit
          },
          // .min.css (minified)
          {
            moduleId: id,
            fileName: sfcFileName,
            extension: `.min${extension}`,
            defaulAssetName: buildDefaultAssetFileName(getFilename(id), `.min${extension}`),
            assetRef: undefined, // will be set after emit
            assetFileName: undefined // will be set after emit
          }
        ]

        // Build the final asset path
        const buildAssetFileName = (defaultName) => {
          const isVueContextComponent = /style\/context\/vue\/components\/(.*)/.exec(defaultName)
          const isServiceInjectedComponent = /style\/services\/.*\/components\/(.*)/.exec(defaultName)
          if (isVueContextComponent) {
            return 'style/components/' + isVueContextComponent[1]
          }
          if (isServiceInjectedComponent) {
            return 'style/components/' + isServiceInjectedComponent[1]
          }
          return defaultName
        }

        // Build base CSS source
        const source = `/**\n * Vue component: ${sfcFileName.replace(/^style\//, '').split(path.sep).join(path.posix.sep)}\n */\n` + code

        // Build postcssrc options based on target asset
        const buildPostCSSProcessOptions = (_assetFileName) => {
          const { ext: extname, dir: dirname, base: basename } = path.parse(_assetFileName)
          return {
            file: { extname, dirname, basename },
            options: { from: id, to: _assetFileName }
          }
        }

        return new Promise((resolve, reject) => {
          Promise.all(extractedInfos.map((extractInfo) => {
            extractInfo.assetFileName = buildAssetFileName(extractInfo.defaulAssetName)
            return postCSSProcess(source, buildPostCSSProcessOptions(extractInfo.assetFileName)).then((result) => {
              extractInfo.assetRef = this.emitFile({
                type: 'asset',
                fileName: extractInfo.assetFileName,
                source: result.css
              })
              extracted.push(extractInfo)
              // Append import to component entrypoint source
              const entryPoint = vueComponentStylesEntryPoints[extractInfo.extension]
              if (entryPoint) {
                entryPoint.source += `\n@import "./${extractInfo.assetFileName.replace(/^style\/components\//, '')}";`
              }
            })
          })).then(() => {
            resolve('')
          }).catch((err) => {
            reject(err)
          })
        })
      }
      return code
    },
    buildEnd (error) {
      if (!error) {
        // Set asset source for Vue component styles entry points
        for (const targetExtension in vueComponentStylesEntryPoints) {
          this.setAssetSource(
            vueComponentStylesEntryPoints[targetExtension].assetRef,
            // source
            vueComponentStylesEntryPoints[targetExtension].source
          )
        }
      }
    },
    generateBundle (options, bundle, isWrite) {
      const getAssets = (callback = (value) => true) => {
        return Object.keys(bundle).reduce((_assets, fileName) => {
          // If asset
          if (bundle[fileName].type === 'asset') {
            if (callback(bundle[fileName])) {
              _assets[fileName] = bundle[fileName]
            }
          }
          return _assets
        }, {})
      }

      // Component assets
      const componentAssets = getAssets((asset) => {
        // If extracted
        return extracted.some((extractInfo) => extractInfo.assetFileName === asset.fileName)
      })

      const componentEntriesAssets = getAssets((asset) => {
        return Object.keys(vueComponentStylesEntryPoints).reduce((assets, extension) => {
          assets.push(vueComponentStylesEntryPoints[extension].assetFileName)
          return assets
        }, []).includes(asset.fileName)
      })

      console.log(
        'Extracted Vue component CSS:\n - ' +
        Object.keys(componentAssets).join('\n - ') + '\n'
      )

      console.log(
        'Generated Vue components main entries:\n - ' +
        Object.keys(componentEntriesAssets).join('\n - ') + '\n'
      )
    }
  }
}
